import gtk


class BzrDialog(gtk.Dialog):
    def __init__(self):
        pass
    
    def disable_widgets(self):
        def _disable(item):
            item.set_sensitive(False)
        self.action_area.foreach(_disable)


    def set_status(self,text):
        self._status.set_markup("<i>%s</i>" % text)
        while gtk.events_pending():
            gtk.main_iteration()
            
class BzrInputDialog(BzrDialog):
    _response = None
    _entry = None
    
    def __init__(self,defaultvalue = "",bigtext = "", text = "",title = "",):
        gtk.Dialog.__init__(self,title,None)
        entry = gtk.Entry()
        hbox = gtk.HBox()
        self.vbox.pack_start(hbox)
        self.vbox.set_spacing(2)
        img = gtk.Image()
        img.set_from_stock(gtk.STOCK_DIALOG_QUESTION,gtk.ICON_SIZE_DIALOG)
        hbox.pack_start(img)
        hbox.set_spacing(10)
        vbox = gtk.VBox()
        vbox.set_spacing(10)
        hbox.pack_start(vbox)

        lbltit = gtk.Label("<big><b>%s</b></big>" % bigtext)#"<big><b>Select path to INIT</b></big>")
        lbltit.set_padding(0,10)
        lbltit.set_use_markup(True)
        lbltit.set_alignment(0,0)
        vbox.pack_start(lbltit)
        lbl = gtk.Label(text)#"Choose which is the path where you want to create this bzr")
        lbl.set_alignment(0,0)
        vbox.pack_start(lbl)
        entry = gtk.Entry()
        entry.set_text(defaultvalue)
        buthbox = gtk.HBox()
        self.entrybox = buthbox
        buthbox.pack_start(entry)
        vbox.pack_start(buthbox)
        self._statusbox = gtk.VBox()
        self._status = gtk.Label()
        self._statusbox.pack_start(self._status)
        self._status.set_use_markup(True)
        vbox.pack_start(self._statusbox)
        self._status.set_alignment(0,0)
        self.vbox.show_all()
        self.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_OK,gtk.RESPONSE_OK)
        self._entry = entry

    def run(self):
        self.set_default_response(gtk.RESPONSE_OK)
        returncode =  gtk.Dialog.run(self)
        return (returncode,self._entry.get_text())

    def disable_widgets(self):
        BzrDialog.disable_widgets(self)
        self._entry.set_sensitive(False)
        
class BzrInputFileDialog(BzrInputDialog):
    _response = None
    _entry = None
    
    def __init__(self,defaultvalue = "",bigtext = "", text = "",title = "",):
        BzrInputDialog.__init__(self,defaultvalue,bigtext,text,title)
        butbrowse = gtk.Button(_("Open"),gtk.STOCK_OPEN)
        butbrowse.connect("clicked",self._clicked)
        butbrowse.show()
        self.entrybox.pack_start(butbrowse)
    
    def _clicked(self,but):
        dlg = gtk.FileChooserDialog("Choose patch",buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL, gtk.STOCK_OK,gtk.RESPONSE_OK))
        ret = dlg.run()
        if ret == gtk.RESPONSE_OK:
            file = dlg.get_filename()
            if file != None and file != '':
                self._entry.set_text(file)
        dlg.destroy()

    def run(self):
        self.set_default_response(gtk.RESPONSE_OK)
        returncode =  gtk.Dialog.run(self)
        return (returncode,self._entry.get_text())

    def disable_widgets(self):
        BzrDialog.disable_widgets(self)
        self._entry.set_sensitive(False)
        
class BzrDobleInputDialog(BzrDialog):
    _return = None
    _response = None
    _entry = None

    def __init__(self,defaultvalue1 = "",
                             defaultvalue2 = "",bigtext = "", text = "",text2 = "",title = "",):
        gtk.Dialog.__init__(self,title,None)

        entry = gtk.Entry()
        hbox = gtk.HBox()
        self.vbox.pack_start(hbox)
        self.vbox.set_spacing(2)
        img = gtk.Image()
        img.set_from_stock(gtk.STOCK_DIALOG_QUESTION,gtk.ICON_SIZE_DIALOG)
        hbox.pack_start(img)
        hbox.set_spacing(10)
        vbox = gtk.VBox()
        vbox.set_spacing(10)
        hbox.pack_start(vbox)

        lbltit = gtk.Label("<big><b>%s</b></big>" % bigtext)#"<big><b>Select path to INIT</b></big>")
        lbltit.set_padding(0,10)
        lbltit.set_use_markup(True)
        lbltit.set_alignment(0,0)
        vbox.pack_start(lbltit)
        lbl = gtk.Label(text)#"Choose which is the path where you want to create this bzr")
        lbl.set_alignment(0,0)
        vbox.pack_start(lbl)
        entry = gtk.Entry()
        entry.set_text(defaultvalue1)
        vbox.pack_start(entry)

        lbl2 = gtk.Label(text2)#"Choose which is the path where you want to create this bzr")
        lbl2.set_alignment(0,0)
        vbox.pack_start(lbl2)
        entry2 = gtk.Entry()
        entry2.set_text(defaultvalue2)
        vbox.pack_start(entry2)

        self._statusbox = gtk.VBox()
        self._status = gtk.Label()
        self._status.set_use_markup(True)
        self._status.set_alignment(0,0)
        self._statusbox.pack_start(self._status)
        vbox.pack_start(self._statusbox)

        self.vbox.show_all()
        self.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_OK,gtk.RESPONSE_OK)
        self._entry = entry
        self._entry2 = entry2

    def run(self):
        self.set_default_response(gtk.RESPONSE_OK)
        returncode = gtk.Dialog.run(self)
        ret = (returncode,self._entry.get_text(),self._entry2.get_text())
        return ret
    
    def disable_widgets(self):
        BzrDialog.disable_widgets(self)
        self._entry.set_sensitive(False)
        self._entry2.set_sensitive(False)


class BzrComitDialog(BzrDialog):
    _return = None
    _response = None
    _entry = None

    def __init__(self,path):
        gtk.Dialog.__init__(self,"Commit",None)

        hbox = gtk.HBox()
        self.vbox.pack_start(hbox)
        self.vbox.set_spacing(2)
        img = gtk.Image()
        img.set_from_stock(gtk.STOCK_DIALOG_QUESTION,gtk.ICON_SIZE_DIALOG)
        hbox.pack_start(img)
        hbox.set_spacing(10)
        vbox = gtk.VBox()
        vbox.set_spacing(10)
        hbox.pack_start(vbox)

        lbltit = gtk.Label("<big><b>Commit changes in %s.</b></big>" % path)
        lbltit.set_padding(0,10)
        lbltit.set_use_markup(True)
        lbltit.set_alignment(0,0)
        vbox.pack_start(lbltit)
        lbl = gtk.Label("Please enter a comment for your commit")
        lbl.set_alignment(0,0)
        vbox.pack_start(lbl)
        scrollw = gtk.ScrolledWindow()
        textview = gtk.TextView()
        scrollw.add(textview)
        scrollw.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
        frame = gtk.Frame()
        frame.add(scrollw)
        vbox.pack_start(frame)

        self._statusbox = gtk.VBox()
        self._status = gtk.Label()
        self._status.set_use_markup(True)
        self._status.set_alignment(0,0)
        self._statusbox.pack_start(self._status)
        vbox.pack_start(self._statusbox)

        self.vbox.show_all()
        self.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_OK,gtk.RESPONSE_OK)
        self._textview = textview

    def run(self):
        self.set_default_response(gtk.RESPONSE_OK)
        returncode = gtk.Dialog.run(self)
        buf = self._textview.get_buffer()
        bounds = buf.get_bounds()
        mytext = buf.get_text(bounds[0],bounds[1])
        ret = (returncode,mytext)
        return ret

    def disable_widgets(self):
        BzrDialog.disable_widgets(self)
        self._textview.set_sensitive(False)
        

        
def _bzrErrorDialog(title, message = None, msgtype='Error'):
    d = gtk.Dialog("Error!",None)

    hbox = gtk.HBox()
    d.vbox.pack_start(hbox)
    d.vbox.set_spacing(2)
    img = gtk.Image()
    img.set_from_stock(gtk.STOCK_DIALOG_ERROR,gtk.ICON_SIZE_DIALOG)
    hbox.pack_start(img)
    hbox.set_spacing(10)
    vbox = gtk.VBox()
    vbox.set_spacing(10)
    hbox.pack_start(vbox)

    lbltit = gtk.Label("<b>%s:</b> %s" % (msgtype,title))
    lbltit.set_padding(0,10)
    lbltit.set_use_markup(True)
    lbltit.set_alignment(0,0)
    vbox.pack_start(lbltit)
    if message != None:
        if type(message) != str:
            message = str(message)
        scrollw = gtk.ScrolledWindow()
        textview = gtk.TextView()
        textview.get_buffer().set_text(message)
        textview.set_wrap_mode(gtk.WRAP_WORD_CHAR)

        #textview.set_size_request(-1,100)
        scrollw.add(textview)
        scrollw.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
        frame = gtk.Frame()
        frame.add(scrollw)
        vbox.pack_start(frame)
    d.vbox.show_all()
    d.add_buttons(gtk.STOCK_OK,gtk.RESPONSE_OK)
    ret = d.run()
    d.destroy()
    return True
    
    
def _bzrInfoDialog(title, message, w_h = None):
    d = gtk.Dialog(title,None)

    hbox = gtk.HBox()
    d.vbox.pack_start(hbox)
    d.vbox.set_spacing(2)
    hbox.set_spacing(10)
    vbox = gtk.VBox()
    vbox.set_spacing(10)
    hbox.pack_start(vbox)
    
    

    scrollw = gtk.ScrolledWindow()
    textview = gtk.TextView()
    textview.get_buffer().set_text(message)
    textview.set_wrap_mode(gtk.WRAP_WORD_CHAR)

    #textview.set_size_request(-1,100)
    scrollw.add(textview)
    scrollw.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
    frame = gtk.Frame()
    frame.add(scrollw)
    vbox.pack_start(frame)
    
    d.vbox.show_all()
    d.add_buttons(gtk.STOCK_OK,gtk.RESPONSE_OK)
    if w_h != None:
        d.set_default_size(w_h[0], w_h[1])
    ret = d.run()
    d.destroy()
    return True

def _bzrQuestionDialog(title, message = None,yestext = None):
    d = gtk.Dialog(title,None)

    hbox = gtk.HBox()
    d.vbox.pack_start(hbox)
    d.vbox.set_spacing(2)
    img = gtk.Image()
    img.set_from_stock(gtk.STOCK_DIALOG_QUESTION,gtk.ICON_SIZE_DIALOG)
    hbox.pack_start(img)
    hbox.set_spacing(10)
    vbox = gtk.VBox()
    vbox.set_spacing(10)
    hbox.pack_start(vbox)

    lbltit = gtk.Label("<big><b>Confirm:</b></big>")
    lbltit.set_use_markup(True)
    lbltit.set_alignment(0,0)
    lbltit.set_padding(0,10)
    vbox.pack_start(lbltit)
    lblquest = gtk.Label(message)
    lblquest.set_alignment(0,0)
    lblquest.set_use_markup(True)
    
    vbox.pack_start(lblquest)    
    d.vbox.show_all()
    if yestext == '':
        yestext = gtk.STOCK_YES
        
    d.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,yestext,gtk.RESPONSE_YES)
    ret = d.run()
    d.destroy()
    return ret

def _bzrDiffDialog(title, diff):
    import pango
    import gtksourceview2 as gtksourceview
    have_gtksourceview = True

#        have_gtksourceview = False
    
    d = gtk.Dialog(title,None)

    ###
    if have_gtksourceview:
        buffer = gtksourceview.Buffer()
        slm = gtksourceview.LanguageManager()
        gsl = slm.get_language("diff")

        #self.apply_colordiff_colors(gsl)
        buffer.set_language(gsl)
        #buffer.set_highlight(True)

        sourceview = gtksourceview.View(buffer)
    else:
        buffer = gtk.TextBuffer()
        sourceview = gtk.TextView(buffer)

    sourceview.set_editable(True)
    sourceview.modify_font(pango.FontDescription("Monospace"))
    #self.add(sourceview)
    sourceview.show()
    ###
    buffer.set_text(diff)
    hbox = gtk.HBox()
    scroll = gtk.ScrolledWindow()
    scroll.add(sourceview)
    hbox.pack_start(scroll)
    
    d.vbox.pack_start(hbox)
    d.vbox.show_all()
    d.set_default_size(700, 400)
    
    d.add_buttons(gtk.STOCK_CLOSE,gtk.RESPONSE_OK)
    ret = d.run()
    d.destroy()
    return ret